/* ===========================================================================
 *        Filename:  node_eqclass.cc
 *     Description:  Node equality class
 * 
 *         Version:  $Rev: 12 $
 *         Changed:  $Date: 2005-09-06 03:26:51 +0200 (Di, 06 Sep 2005) $
 *         Licence:  GPL (read COPYING file for details)
 * 
 *          Author:  Erich Schubert (eS), erich@debian.org
 *                   Institut für Informatik, LMU München
 * ======================================================================== */
#include "node_eqclass.h"

namespace SSD {

NodeEqClass::NodeEqClass(Node* n) :
	label(n->label), content(n->content) { }

NodeEqClass::NodeEqClass(Node& n) :
	label(n.label), content(n.content) { }

std::ostream &operator<<(std::ostream &out, const NodeEqClass ec) {
    return out << "NEqC(" << ec.label << "," << ec.content << ")";
}

}
